from manager.serverCenter import server
from flask import request
from flask_socketio import join_room,leave_room



globalStatusSearchUSer=[]

andriodStatusSearchUser=[]

iosStatusSearchUser=[]


appiumLogUser=[]




def usbInfoFlush(data):
    # print(data)
    for each in globalStatusSearchUSer:
        server.socketio.emit('usbFlush',data,to=each)
        
def sshInfoFlush(data):
    # print(data)
    for each in globalStatusSearchUSer:
        server.socketio.emit('sshFlush',data,to=each)
        
def adbInfoFlush(data):
    for each in andriodStatusSearchUser:
        server.socketio.emit('adbFlush',data,to=each)
        
def appiumStatus(data):
    # print(data)
    for each in globalStatusSearchUSer:
        server.socketio.emit('appiumstatus',data,to=each)
        
def appiumLog(data):
    for each in globalStatusSearchUSer:
        server.socketio.emit('appiumlog',data,to=each)
        
def IosConnectInfo(data):
    print(data)
    for each in iosStatusSearchUser:
        server.socketio.emit('iosinfo',data,to=each)
        
def sendappiumLog(data):
    print("发送日志")
    print(data)
    for each in appiumLogUser:
        server.socketio.emit('sendappiumLog',data,to=each)

onEvent=[
    ["主机服务","列表刷新",usbInfoFlush],
    ["主机服务","adb信息",adbInfoFlush],
    ["主机服务","隧道状态",sshInfoFlush],
    ["主机服务","appium状态",appiumStatus],
    ["主机服务","appium日志",appiumLog],
    ["主机服务","ios连接信息",IosConnectInfo],
]




@server.socketio.on('join')
def on_join(data):
    join_room(data)

@server.socketio.on('leave')
def on_leave(data):
    leave_room(data)

@server.socketio.on('disconnect')
def disconnect():
    request.sid in globalStatusSearchUSer and globalStatusSearchUSer.remove(request.sid)
    request.sid in andriodStatusSearchUser and andriodStatusSearchUser.remove(request.sid)
    request.sid in iosStatusSearchUser and iosStatusSearchUser.remove(request.sid)
    request.sid in appiumLogUser and appiumLogUser.remove(request.sid)
    if not appiumLogUser:
        server.listener.off("主机服务","appium日志",sendappiumLog)

@server.socketio.on('usbInfo')
def usbInfo():
    '''
    查看usb状态
    '''
    globalStatusSearchUSer.append(request.sid)
    
@server.socketio.on('leaveUsbinfo')
def leaveUsbinfo():
    '''
    从查看状态退出
    '''
    request.sid in globalStatusSearchUSer and globalStatusSearchUSer.remove(request.sid)
    
@server.socketio.on('leaveAdbinfo')
def leaveAdbinfo():
    '''
    退出查看adb信息
    '''
    request.sid in andriodStatusSearchUser and andriodStatusSearchUser.remove(request.sid)

@server.socketio.on('adbInfo')
def getStatus():
    andriodStatusSearchUser.append(request.sid)
    
@server.socketio.on('leaveIOSinfo')
def leaveAdbinfo():
    '''
    退出查看adb信息
    '''
    request.sid in iosStatusSearchUser and iosStatusSearchUser.remove(request.sid)

@server.socketio.on('IOSInfo')
def getStatus():
    iosStatusSearchUser.append(request.sid)
      
@server.socketio.on('connectUsb')
def connectUsb(key):
    print(key)
    server.listener.emit("连接usb",key)
    
@server.socketio.on('killproxy')
def killproxy():
    server.listener.emit("杀死转发链路")
    
@server.socketio.on('restartAppium')
def restartAppium():
    '''
    重启appium
    '''
    server.listener.emit("重启appium")
    print("重启appium")
    
@server.socketio.on('startAppium')
def restartAppium():
    print("启动appium")
    server.listener.emit("启动appium")
    
@server.socketio.on('connectIOS')
def connectIos(WDAID):
    print(WDAID)
    server.listener.emit("连接ios",WDAID)
    
@server.socketio.on('disconnectIOS')
def connectIos(WDAID):
    server.listener.emit("断开ios连接",WDAID)
    
    
@server.socketio.on('appiumLog')
def appiumLog():
    if not appiumLogUser:
        print("添加监听")
        server.listener.on("主机服务","appium日志",sendappiumLog)
    appiumLogUser.append(request.sid)
    print(appiumLogUser)
    
@server.socketio.on('leaveappiumLog')
def appiumLog():
    request.sid in appiumLogUser and appiumLogUser.remove(request.sid)
    if not appiumLogUser:
        print("移除监听")
        server.listener.off("主机服务","appium日志",sendappiumLog)
    print(appiumLogUser)
     
server.listener.addevent("连接usb","触发usbip绑定事件,参数为需要连接的key")
server.listener.addevent("杀死转发链路","杀死ssh隧道转发")
server.listener.addevent("重启appium","重启appium服务")
server.listener.addevent("启动appium","启动appium服务")
server.listener.addevent("连接ios","连接ios，参数为webdriveragentId")
server.listener.addevent("断开ios连接","断开所有ios的连接")
    
for each in onEvent:
    server.listener.on(*each)

    
    

